# -*- coding: utf-8 -*-
"""
    This module allows you to run code on the script's main thread easely. This can be used from the main thread to return to the script's thread.
    
    Example:
    
    import execthread
    
    def sayHello() -> None:
        print("Hello World!")
    
    execthread.run_sync(sayHello)
"""

import pyto
from time import sleep

__PyThread__ = PyThread

def runSync(code):
    raise NameError("`runSync` was renamed to `run_sync`")

def runAsync(code):
    raise NameError("`runAsync` was renamed to `run_async`")

def run_async(code):
    """
    Runs the given code asynchronously on the script's thread.
        
    Args:
        code: Code to execute in the script's thread.
    """
    __PyThread__.runAsync(code)

def run_sync(code):
    """
    Runs the given code synchronously on the script's thread.
        
    Args:
        code: Code to execute in the script's thread.
    """
    __PyThread__.runSync(code)
    sleep(0.1)


