# -*- coding: utf-8 -*-
"""
This module contains classes from the main app used by Pyto.

This module is only for internal or plugin use.
"""

from rubicon.objc import *

NSBundle = ObjCClass("NSBundle")

def __isMainApp__():
    return (NSBundle.mainBundle.bundleURL.lastPathComponent == "Pyto.app")

def __Class__(name):
    if (__isMainApp__()):
        return ObjCClass("Pyto."+name)
    else:
        return ObjCClass("PytoCore."+name)

PyMainThread = ObjCClass("PyMainThread")
PyThread = __Class__("PyThread")

PyInputHelper = __Class__("PyInputHelper")
PyOutputHelper = __Class__("PyOutputHelper")
PySharingHelper = __Class__("PySharingHelper")
PySelector = __Class__("PySelector")
SelectorTarget = __Class__("_Selector")
FilePicker = __Class__("PyFilePicker")
Alert = __Class__("PyAlert")
Python = __Class__("Python")
ConsoleViewController = __Class__("ConsoleViewController")

if __isMainApp__():
    REPLViewController = __Class__("REPLViewController")
else:
    REPLViewController = None

if (__isMainApp__()):
    ReviewHelper = __Class__("ReviewHelper")
    EditorViewController = __Class__("EditorViewController")
else:
    ReviewHelper = None
    EditorViewController = None

all = ["PyMainThread", "PyThread", "PyInputHelper", "PyOutputHelper", "PySharingHelper", "PySelector", "SelectorTarget", "FilePicker", "Alert", "Python", "ConsoleViewController", "ReviewHelper", "EditorViewController", "REPLViewController"]
