"""
This module gives you access to the UI.
"""

from pyto import *
from time import sleep
import mainthread
import threading

def mainLoop():
    raise NameError("`mainLoop` was renamed to `main_loop`")

def showViewController(viewController, completion=None):
    raise NameError("`showViewController` was renamed to `show_view_controller`")

def closeViewController():
    raise NameError("`closeViewController` was renamed to `close_view_controller`")

def main_loop():
    """
    This runs a loop while the UI is shown to keep the program running. You should always call this function after showing an interactive UI.
    """
    
    ConsoleViewController.isMainLoopRunning = True
    
    while (ConsoleViewController.isMainLoopRunning):
        sleep(1)

def show_view_controller(viewController, completion=None):
    """
    Shows the given View controller.
        
    Args:
        viewController: An `UIViewController` to show.
        completion: Code to call as completion.
    """
    
    ConsoleViewController.visible.showViewController(viewController, completion=completion)

def close_view_controller():
    """
    Closes the currently presented View controller.
    """
    
    ConsoleViewController.visible.closePresentedViewController()
    ConsoleViewController.isMainLoopRunning = False

